
TYPO3.Fluid - Bug # 45071

Status: Closed Priority: Won't have this time
Author: Thiago Colares Category: View
Created: 2013-02-01 Assigned To:
Updated: 2013-08-14 Due date:
Has patch: No
Affected Flow version: FLOW3 1.1.0
Subject: Fluid tries to parse inside an in-HTML Javascript code
Description

Example. When I try this:

<script type="text/javascript">
    $(function(){
        var id = '#{id}';
        $(id).datepicker({
            dateFormat: "dd/mm/yy",
            changeMonth: true,
            changeYear: true
        });

    });
</script>

I got this HTML as result:

<script type="text/javascript">
    $(function(){
        var id = '#dummy-id-01';
        $(id).datepicker(Array);
</script>

To overcome this issue, we inserted a dummy comment. :)

<script type="text/javascript">
    $(function(){
        var id = '#{id}';
        $(id).datepicker({
            dateFormat: "dd/mm/yy", // DO NOT EVER REMOVE THIS COMMENT!
            changeMonth: true,
            changeYear: true
        });

    });
</script>
So, The HTML results is as expected:

<script type="text/javascript">
    $(function(){
        var id = '#dummy-id-01';
        $(id).datepicker({
            dateFormat: "dd/mm/yy", // DO NOT EVER REMOVE THIS COMMENT!
            changeMonth: true,
            changeYear: true
        });
</script>

Related issues:
duplicates TYPO3.Fluid - Feature # 43356: Allow Fluid arrays only in ViewHelp... Resolved 2012-11-27
duplicates TYPO3.Fluid - Bug # 44140: Unlucky JavaScript syntax can break inl... Resolved 2012-12-20

History
#1 - 2013-02-01 14:10 - Thiago Colares

NOTE: the FLUID parse a Javascript array, but it should not!!

#2 - 2013-02-01 15:44 - Adrian Föder
- Status changed from New to Closed
- Priority changed from Should have to Won't have this time

Thiago, this is as per-design and is "fixed" in version 2.0.
Meanwhile, wrap your JavaScript code in CDATA blocks, like

 1<script type="text/javascript">
 2<![CDATA[
 3    $(function(){
 4        var id = '#]]>{id}<![CDATA[';
 5        $(id).datepicker({
 6            dateFormat: "dd/mm/yy",
 7            changeMonth: true,
 8            changeYear: true
 9        });
10
11    });
12]]></script>

Untested.

Feel free to reopen if necessary.

#3 - 2013-02-01 22:28 - Thiago Colares

Ok! Thanks for clarify me!
Adrian Föder wrote:

Thiago, this is as per-design and is "fixed" in version 2.0.
Meanwhile, wrap your JavaScript code in CDATA blocks, like

[...]

Untested.

Feel free to reopen if necessary.

#4 - 2013-08-14 15:39 - Karsten Dambekalns
- Target version changed from 2052 to 1.1.1
